datablock fxDtsBrickData(brickTeleporterData)
{
	brickFile = "./Teleporter.blb";
	collisionShapeName = "./Teleporter.dts";
	category = "Special";
	subcategory = "Interactive";
	uiName = "Teleporter";
};

datablock StaticShapeData(ColCubeShape)
{
	shapeFile = "Add-Ons/Server_Planets/ColCube.dts";
};

datablock StaticShapeData(PlanetShape)
{
	shapeFile = "Add-Ons/Server_Planets/World_Model.dts";
};

datablock StaticShapeData(PlanetGasGiantShape)
{
	shapeFile = "Add-Ons/Server_Planets/World_GasModel.dts";
};

datablock StaticShapeData(PlanetRingShape)
{
	shapeFile = "Add-Ons/Server_Planets/World_Ring.dts";
};

datablock StaticShapeData(PlanetMiniShape)
{
	shapeFile = "Add-Ons/Server_Planets/World_Mini.dts";
};

datablock StaticShapeData(PlanetMiniRingShape)
{
	shapeFile = "Add-Ons/Server_Planets/World_Miniring.dts";
};

datablock StaticShapeData(Scatter_RockShape)
{
	shapeFile = "Add-Ons/Server_Planets/Scatter_Rock.dts";
};

datablock StaticShapeData(Scatter_TreePineShape)
{
	shapeFile = "Add-Ons/Server_Planets/Tree_Pine.dts";
};

datablock PlayerData(PlayerPlanetJetArmor : PlayerStandardArmor)
{
	canJet = 0;
	uiName = "";
};

package Planets
{
	function Armor::onAdd(%data, %this)
	{
		GravityGroup.add(%this);
		Parent::onAdd(%data, %this);
	}
	
	function Armor::onTrigger(%data, %this, %trig, %tog)
	{
		%this.trigger[%trig] = %tog;
		Parent::onTrigger(%data, %this, %trig, %tog);
	}
	
	function BrickDeployProjectile::onCollision(%data, %this, %a, %b, %c, %d, %e)
	{
		%this.hasCollided = 1;
		Parent::onCollision(%data, %this, %a, %b, %c, %d, %e);
	}
	
	function brickTeleporterData::onAdd(%data, %this)
	{
		if (%this.isPlanted())
		{
			if (isObject(%world = getParentWorld(%this, -1)))
			{
				%this.parentWorld = %world;
				%this.schedule(0, "worldOwnerCheck");
			}
			else
			{
				%this.teleportID = TeleportersGroup.nextID++;
				TeleportersGroup.add(%this);
			}
		}
		Parent::onAdd(%data, %this);
	}
	
	function disconnect(%a, %b, %c, %d, %e)
	{
		cancel($GravTick);
		GravityGroup.delete();
		TeleportersGroup.delete();
		WorldGroup.delete();
		WorldRingGroup.delete();
		ScatterGroup.delete();
		return Parent::disconnect(%a, %b, %c, %d, %e);
	}
	
	function FlyingVehicleData::onAdd(%data, %this)
	{
		GravityGroup.add(%this);
		Parent::onAdd(%data, %this);
	}
	
	function GameConnection::onClientEnterGame(%cl)
	{
		Parent::onClientEnterGame(%cl);
		if(isObject(%pl = %cl.player) && ((%transvel = $SystemPlanets_TransVel[%cl.bl_id]) !$= ""))
		{
			%pl.setTransform(getWords(%transvel, 0, 6));
			%pl.setVelocity(getWords(%transvel, 7, 9));
		}
	}
	
	function GameConnection::onClientLeaveGame(%cl)
	{
		if(isObject(%pl = %cl.player))
			$SystemPlanets_TransVel[%cl.bl_id] = %pl.getTransform() SPC %pl.getVelocity();
		Parent::onClientLeaveGame(%cl);
	}
	
	function Projectile::onRemove(%data, %this)
	{
		if (%this.getDatablock().getID() == BrickDeployProjectile.getID()
			&& !%this.hasCollided && isObject(%cl = %this.client) && isObject(%pl = %cl.player))
		{
			%world = getParentWorld(%this, -1);
			if (%world.worldClass == 1)
			{
				%vel = %this.getVelocity();
				%angle = mFloatLength(mAtan(getWord(%vel, 0), getWord(%vel, 1)) / ($PI / 2), 0) + 1;
				if (isObject(%temp = %pl.tempbrick))
				{
					%angle = (%angle + %temp.getDatablock().orientationFix) & 3;
					%temp.setTransform(%this.getPosition() @ " 0 0 1 " @ %angle * 1.57079633);
				}
				else if (%cl.currInv != -1)
				{
					%brickData = %cl.inventory[%cl.currInv];
					%angle = (%angle + %brickData.orientationFix) & 3;
					%temp = new fxDtsBrick()
					{
						client = %cl;
						angleID = %angle;
						colorID = %cl.currentColor;
						datablock = %brickData;
						position = %this.getPosition();
						rotation = "0 0 1 " @ %angle * 1.57079633;
					};
					%cl.brickgroup.add(%temp);
					%pl.tempbrick = %temp;
				}
			}
		}
		Parent::onRemove(%data, %this);
	}
	
	function servercmdPlantBrick(%cl)
	{
		if (!isObject(%pl = %cl.player) || !isObject(%temp = %pl.tempbrick))
			return -1;
		if (!isObject(%world = getParentWorld(%temp, -1)) || %world.worldClass != 1)
			return Parent::servercmdPlantBrick(%cl);
		if (!isObject(FloatplantHelper))
			new StaticShape(FloatplantHelper)
			{
				datablock = ColCubeShape;
			};
		%shape = FloatplantHelper;
		%data = %temp.getDatablock();
		if(%temp.angleID & 1)
			%shape.setScale(%data.brickSizeY / 2 SPC %data.brickSizeX / 2 SPC 0.2);
		else
			%shape.setScale(%data.brickSizeX / 2 SPC %data.brickSizeY / 2 SPC 0.2);
		%shape.setTransform(vectorSub(%temp.getPosition(), "0 0 " @ %data.brickSizeZ / 10 + 0.1) @ " 1 0 0 0");
		%brick = Parent::servercmdPlantBrick(%cl);
		%shape.setTransform("-999999 -999999 -999999 1 0 0 0");
	}
	
	function WheeledVehicleData::onAdd(%data, %this)
	{
		GravityGroup.add(%this);
		Parent::onAdd(%data, %this);
	}
};
activatePackage("Planets");

function Projectile::onRemove() { }

function fxDtsBrick::worldOwnerCheck(%brick, %msg)
{
	if (isObject(%world = %brick.parentWorld) && %world.systemFinderID != %brick.getGroup().bl_id)
	{
		%brick.client.centerPrint("Can't plant a teleporter here - you don't own this planet!", 3);
		%brick.delete();
	}
	else if (isObject(%world.teleporter))
	{
		%brick.client.centerPrint("Can't plant a teleporter here - this planet already has one!", 3);
		%brick.delete();
	}
	else
	{
		%brick.teleportID = 0;
		%world.teleporter = %brick;
		TeleportersGroup.add(%brick);
	}
}

function WheeledVehicle::addVelocity(%this, %vel)
{
	%this.setVelocity(vectorAdd(%this.getVelocity(), %vel));
}

function FlyingVehicle::addVelocity(%this, %vel)
{
	%this.setVelocity(vectorAdd(%this.getVelocity(), %vel));
}

function gravityTick(%last, %lastFull)
{
	cancel($GravTick);
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	%timeFull = vectorDist(%lastFUll, %now) / 1000;
	if (%timeFull >= 0.25)
	{
		%lastFull = %now;
		%doFull = 1;
	}
	
	%count = GravityGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%obj = GravityGroup.getObject(%i);
		if(%obj.trigger4 && !isObject(%obj.getMountedImage(0)))
		{
			if(%obj.getDatablock().getID() != PlayerPlanetJetArmor.getID())
			{
				%obj.oldPlayerDB = %obj.getDatablock();
				%obj.changeDatablock(PlayerPlanetJetArmor);
			}
			%obj.addVelocity(vectorScale(%obj.getEyeVector(), %time * 25));
		}
		else if(%obj.oldPlayerDB !$= "")
		{
			%obj.changeDatablock(%obj.oldPlayerDB);
			%obj.oldPlayerDB = "";
		}
		%type = %obj.getType();
		%world = getParentWorld(%obj, %time);
		if (!(%type & $Typemasks::PlayerObjectType))
			%obj.addVelocity(vectorScale("0 0 20", %time));
		if (isObject(%world) && (%type & $Typemasks::PlayerObjectType)
			&& %obj.lastFoundWorld != %world && %world.systemName $= ""
			&& !$Pref::Server::Planets::CantClaimPlanets[%cl.bl_id])
		{
			%obj.lastFoundWorld = %world;
			%obj.client.chatMessage("\c6You've discovered a new " @ (%world.isMoon ? "moon!" : "planet!"));
			%obj.client.chatMessage("\c6You can name it with \"\c2/namePlanet your name\"!");
		}
		if (checkIsGrounded(%obj))
		{
			if (%type & $Typemasks::VehicleObjectType)
				%obj.addVelocity(vectorScale("0 0 -20", %time));
			else
				%obj.addVelocity(vectorScale("0 0 -2.5", %time));
			if (!isObject(%world) && !$Planets::UseGravServer)
				getGravitationForce(%obj, %time);
			showNotifyText(%obj);
			continue;
		}
		if (isObject(%world))
		{
			if (%world.worldClass == 0)
				%obj.addVelocity(vectorScale(%world.gravity, %time));
			else if (%world.worldClass == 1)
				gasGiantPhysics(%obj, %world, %time);
		}
		else
			%obj.addVelocity(vectorScale(getGravitationForce(%obj, %time), %time));
		showNotifyText(%obj);
	}
	$GravTick = schedule(16, 0, "gravityTick", %now, %lastFull);
}

function checkIsGrounded(%obj)
{
	%type = %obj.getType();
	if (%type & $Typemasks::PlayerObjectType)
		%pos = %obj.getHackPosition();
	else if (%type & $Typemasks::VehicleObjectType)
		%pos = %obj.getWorldBoxCenter();
	else
		%pos = %obj.getPosition();
	
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType
		| $Typemasks::StaticShapeObjectType | $Typemasks::TerrainObjectType
		| $Typemasks::VehicleObjectType;
	if (%type & $Typemasks::VehicleObjectType)
	{
		%ray = containerRaycast(%pos = %obj.getPosition(), vectorAdd(%pos, "0 0 -1"), %mask, %obj);
		return isObject(firstWord(%ray));
	}
	else
	{
		%ray = containerRaycast(%pos = %obj.getPosition(), vectorAdd(%pos, "0 0 -0.2"), %mask, %obj);
		return isObject(firstWord(%ray));
	}
}

function getParentWorld(%obj, %time)
{
	%type = %obj.getType();
	if (%type & $Typemasks::PlayerObjectType)
		%pos = %obj.getHackPosition();
	else if (%type & $Typemasks::VehicleObjectType)
		%pos = %obj.getWorldBoxCenter();
	else
		%pos = %obj.getPosition();
	
	if (isObject(%parent = %obj.parentWorld) && vectorDist(%obj.getPosition(), %parent.getPosition()) <= %parent.radius)
		return %parent;
	
	if(%time >= 0 && $Planets::UseGravServer)
	{
		GravClient.send("Parent "@%obj SPC %pos SPC %time SPC $Pref::Server::Planets::GravConst@ "\r\n");
		return -1;
	}
	
	%parent = -1;
	%count = WorldGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%world = WorldGroup.getObject(%i);
		%radius = %world.radius;
		%loc = %world.getPosition();
		if (mAbs(getWord(%pos, 0) - getWord(%loc, 0)) > %radius)
			continue;
		if (mAbs(getWord(%pos, 1) - getWord(%loc, 1)) > %radius)
			continue;
		if (mAbs(getWord(%pos, 2) - getWord(%loc, 2)) > %radius)
			continue;
		%dist = vectorDist(%pos, %loc);
		if (%dist > %radius)
			continue;
		if (%dist < %minDist || %minDist $= "")
		{
			%minDist = %dist;
			%parent = %world;
		}
	}
	%obj.parentWorld = %parent;
	return %parent;
}

function getGravitationForce(%obj, %time)
{
	%type = %obj.getType();
	if (%type & $Typemasks::PlayerObjectType)
		%pos = %obj.getHackPosition();
	else if (%type & $Typemasks::VehicleObjectType)
		%pos = %obj.getWorldBoxCenter();
	else
		%pos = %obj.getPosition();
	
	if(%time >= 0 && $Planets::UseGravServer)
	{
		GravClient.send("Calc "@%obj SPC %pos SPC %time SPC $Pref::Server::Planets::GravConst @ "\r\n");
		return "0 0 0";
	}
	
	%finForce = "0 0 0";
	%count = WorldGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%world = WorldGroup.getObject(%i);
		if ($Pref::Server::Planets::GravMode <= 0 && %world.isMoon && %obj.parentWorld != %world.parentWorld)
			continue;
		%dist = vectorDist(%pos, %world.getPosition());
		%force = ($Pref::Server::Planets::GravConst * %world.mass) / (%dist * %dist);
		if (%force > %maxForce)
		{
			%maxForce = %force;
			%parent = %world;
		}
		%dir = vectorNormalize(vectorSub(%world.getPosition(), %pos));
		%finForce = vectorAdd(%finForce, vectorScale(%dir, %force));
	}
	%obj.parentWorld = %parent;
	return %finForce;
}

function gasGiantPhysics(%obj, %world, %time)
{
	%type = %obj.getType();
	if (%type & $Typemasks::PlayerObjectType)
		%pos = %obj.getHackPosition();
	else if (%type & $Typemasks::VehicleObjectType)
		%pos = %obj.getWorldBoxCenter();
	else
		%pos = %obj.getPosition();
	
	%dist = vectorDist(%pos, %world.getPosition());
	%depth = %dist / %world.radius;
	%drag = mCos(%depth * 1.57077) * 0.8;
	%obj.setVelocity(vectorScale(%obj.getVelocity(), mPow(1 - %drag, %time)));
	if ($Pref::Server::GravMode >= 2)
	{
		%force = getGravitationForce(%obj, %time);
		%myForce = ($Pref::Server::Planets::GravConst * %world.mass) / (%dist * %dist);
		%dir = vectorNormalize(vectorSub(%world.getPosition(), %pos));
		%force = vectorSub(vectorScale(%dir, %myForce * %time));
		%obj.addVelocity(%force);
	}
	if (%dist >= 1)
	{
		%dMass = %world.mass * %depth * %depth * %depth;
		%force = ($Pref::Server::Planets::GravConst * %dMass) / (%dist * %dist);
		%dir = vectorNormalize(vectorSub(%world.getPosition(), %pos));
		%obj.addVelocity(vectorScale(%dir, %force * %time));
	}
}

function showNotifyText(%pl)
{
	if (!(%pl.getType() & $Typemasks::PlayerObjectType))
		return;
	if (isObject(%world = %pl.parentWorld))
	{
		if (vectorDist(%pl.getHackPosition(), %world.getPosition()) <= %world.radius * 5)
		{
			if (!%pl.notified || %pl.lastWorld != %world)
			{
				if (%world.isMoon)
				{
					%parentName = %world.parentWorld.systemName;
					if (%parentName $= "")
						%parentName = "Unnamed Planet";
					if (%world.systemName !$= "")
					{
						%discoverer = %world.systemFinder;
						%pl.client.centerPrint("<font:arial:16><color:FFFF00>Now entering<br><font:arial:40><color:FFFFFF>" @ %world.systemName @ "<font:arial:20><br>Moon of " @ %parentName @ "<font:arial:12><br><br>Discovered by "@%discoverer, 5);
					}
					else
						%pl.client.centerPrint("<font:arial:16><color:FFFF00>Now entering<br><font:arial:40><color:FFFFFF>Unnamed Moon<font:arial:20><br>Moon of " @ %parentName @ "<font:arial:12><br><br>Undiscovered", 5);
				}
				else
				{
					if (%world.systemName !$= "")
					{
						%discoverer = %world.systemFinder;
						%pl.client.centerPrint("<font:arial:16><color:FFFF00>Now entering<br><font:arial:40><color:FFFFFF>" @ %world.systemName @ "<font:arial:12><br><br>Discovered by "@%discoverer, 5);
					}
					else
						%pl.client.centerPrint("<font:arial:16><color:FFFF00>Now entering<br><font:arial:40><color:FFFFFF>Unnamed Planet<font:arial:12><br><br>Undiscovered", 5);
				}
				%pl.lastWorld = %world;
			}
			%pl.notified = 1;
		}
		else
		{
			if (%pl.notified)
			{
				%name = %pl.lastWorld.systemName;
				if (%name $= "")
					%name = "Unnamed " @ (%pl.lastWorld.isMoon ? "Moon" : "Planet");
				if (%pl.lastWorld.isMoon)
				{
					%parentName = %pl.lastWorld.parentWorld.systemName;
					if (%parentName $= "")
						%parentName = "Unnamed Planet";
					%pl.client.centerPrint("<font:arial:16><color:FFFF00>Now leaving<br><font:arial:40><color:FFFFFF>" @ %name @ "<font:arial:20><br>Moon of " @ %parentName, 5);
				}
				else
					%pl.client.centerPrint("<font:arial:16><color:FFFF00>Now leaving<br><font:arial:40><color:FFFFFF>" @ %name, 5);
			}
			%pl.notified = 0;
		}
	}
}

function getCurrentTelepad(%obj)
{
	%type = %obj.getType();
	if (%type & $Typemasks::PlayerObjectType)
		%pos = %obj.getHackPosition();
	else if (%type & $Typemasks::VehicleObjectType)
		%pos = %obj.getWorldBoxCenter();
	else
		%pos = %obj.getPosition();
	%x = getWord(%pos, 0);
	%y = getWord(%pos, 1);
	%z = getWord(%pos, 2);
	
	%count = TeleportersGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%tele = TeleportersGroup.getObject(%i);
		%loc = %tele.getPosition();
		if (%x <= getWord(%loc, 0) + 1.5 && %x >= getWord(%loc, 0) - 1.5
			&& %y <= getWord(%loc, 1) + 1.5 && %y >= getWord(%loc, 1) - 1.5
			&& %z <= getWord(%loc, 2) + 1.8 && %z >= getWord(%loc, 2) - 1.2)
			return %tele;
	}
	return -1;
}

function findTelepadByName(%name)
{
	%found = -1;
	%count = TeleportersGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%tele = TeleportersGroup.getObject(%i);
		if (isObject(%world = %tele.parentWorld) && %world.systemName $= %name)
			return %tele;
		if ("_" @ strReplace(%name, " ", "_") !$= %tele.getName())
			continue;
		if (%tele.teleportID < %minID || %minID $= "")
		{
			%found = %tele;
			%minID = %tele.teleportID;
		}
	}
	return %found;
}

function servercmdGoto(%cl, %n0, %n1, %n2, %n3, %n4, %n5, %n6, %n7, %n8, %n9)
{
	for (%i = 0; %i < 10; %i++)
		%name = %name SPC %n[%i];
	%name = trim(stripMLControlChars(%name));
	while ((%temp = strReplace(%name, "  ", " ")) !$= %name)
		%name = %temp;
	if (!isObject(%pl = %cl.player))
	{
		%cl.chatMessage("\c6You do not have a player object!");
		return;
	}
	if (!isObject(%tele = getCurrentTelepad(%pl)))
	{
		%cl.chatMessage("\c6You are not on a teleporter!");
		return;
	}
	if (%name $= "")
	{
		%cl.chatMessage("\c6You must put in a destination name!");
		return;
	}
	if (!isObject(%goal = findTelepadByName(%name)))
	{
		%cl.chatMessage("\c6Unknown destination \"" @ %name @ "\"!");
		return;
	}
	%offset = vectorSub(%pl.getPosition(), %tele.getPosition());
	%pl.setTransform(vectorAdd(%goal.getPosition(), %offset));
	if (isObject(%world = %goal.parentWorld))
		%cl.chatMessage("\c6Teleported to " @ %goal.parentWorld.systemName @ "!");
	else
		%cl.chatMessage("\c6Teleported to " @ getSubStr(%name = %goal.getName(), 1, strLen(%name) - 1) @ "!");
}

function servercmdNamePlanet(%cl, %n0, %n1, %n2, %n3, %n4, %n5, %n6, %n7, %n8, %n9)
{
	if ($Pref::Server::Planets::CantClaimPlanets[%cl.bl_id])
	{
		%cl.chatMessage("\c6Your ability to claim planets has been revoked!");
		return;
	}
	for (%i = 0; %i < 10; %i++)
		%name = %name SPC %n[%i];
	%name = trim(stripMLControlChars(%name));
	while ((%temp = strReplace(%name, "  ", " ")) !$= %name)
		%name = %temp;
	if (!isObject(%pl = %cl.player))
	{
		%cl.chatMessage("\c6You do not have a player object!");
		return;
	}
	if (!isObject(%world = %pl.lastFoundWorld))
	{
		%cl.chatMessage("\c6You have not yet discovered any planets!");
		return;
	}
	if (%world.systemName !$= "")
	{
		%cl.chatMessage("\c6Someone else has already named this planet!");
		return;
	}
	if (%name $= "Unnamed Planet")
	{
		%cl.chatMessage("\c6You can't name your planet \"Unnamed Planet\"!");
		return;
	}
	if (%name $= "Unnamed Moon")
	{
		%cl.chatMessage("\c6You can't name your planet \"Unnamed Moon\"!");
		return;
	}
	if ((%len = strLen(%name)) > 40)
	{
		%cl.chatMessage("\c6Your planet name must be 40 characters or less!");
		return;
	}
	%legal = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";
	for (%i = 0; %i < %len; %i++)
		if (strPos(%legal, getSubStr(%name, %i, 1)) == -1)
		{
			%cl.chatMessage("\c6Your planet name must only contain printable ASCII characters!");
			return;
		}
	if (%name $= "")
	{
		%cl.chatMessage("\c6You must put in a planet name!");
		return;
	}
	%count = WorldGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%temp = WorldGroup.getObject(%i);
		if (%temp.systemName $= %name)
		{
			%cl.chatMessage("\c6There is already a planet or moon named " @ %temp.systemName @ "!");
			return;
		}
	}
	%id = %world.systemID;
	%world.systemName = %name;
	%world.systemFinder = %cl.name;
	%world.systemFinderID = %cl.bl_id;
	if (%world.isMoon)
	{
		%parentID = %world.parentWorld.systemID;
		$SystemPlanets_Name[%parentID, %id] = %name;
		$SystemPlanets_Finder[%parentID, %id] = %cl.name;
		$SystemPlanets_FinderID[%parentID, %id] = %cl.bl_id;
	}
	else
	{
		$SystemPlanets_Name[%id] = %name;
		$SystemPlanets_Finder[%id] = %cl.name;
		$SystemPlanets_FinderID[%id] = %cl.bl_id;
	}
	export("$SystemPlanets_*", "config/server/Planets_" @ $Pref::Server::Planets::SystemSeed @ ".cs");
	%cl.chatMessage("\c6You have named your " @ (%world.isMoon ? "moon " : "planet ") @ %name @ "!");
	%pl.lastFoundWorld = "";
}

function servercmdRenamePlanet(%cl, %n0, %n1, %n2, %n3, %n4, %n5, %n6, %n7, %n8, %n9)
{
	for (%i = 0; %i < 10; %i++)
		%name = %name SPC %n[%i];
	%name = trim(strReplace(stripMLControlChars(%name), "\xA0", " "));
	while ((%temp = strReplace(%name, "  ", " ")) !$= %name)
		%name = %temp;
	if (!isObject(%pl = %cl.player))
	{
		%cl.chatMessage("\c6You do not have a player object!");
		return;
	}
	if (!isObject(%world = %pl.parentWorld))
	{
		%cl.chatMessage("\c6You are not at a planet!");
		return;
	}
	if (%world.systemFinderID != %cl.bl_id)
	{
		if (%world.systemName $= "")
		{
			%pl.lastFoundWorld = %world;
			servercmdNamePlanet(%cl, %name);
		}
		else
			%cl.chatMessage("\c6You did not discover " @ %world.systemName @ "!");
		return;
	}
	if (%name $= "Unnamed Planet")
	{
		%cl.chatMessage("\c6You can't name your planet \"Unnamed Planet\"!");
		return;
	}
	if (%name $= "Unnamed Moon")
	{
		%cl.chatMessage("\c6You can't name your planet \"Unnamed Moon\"!");
		return;
	}
	if ((%len = strLen(%name)) > 40)
	{
		%cl.chatMessage("\c6Your planet name must be 40 characters or less!");
		return;
	}
	%legal = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";
	for (%i = 0; %i < %len; %i++)
		if (strPos(%legal, getSubStr(%name, %i, 1)) == -1)
		{
			%cl.chatMessage("\c6Your planet name must only contain printable ASCII characters!");
			return;
		}
	if (%name $= "")
	{
		%cl.chatMessage("\c6You must put in a planet name!");
		return;
	}
	%count = WorldGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%temp = WorldGroup.getObject(%i);
		if (%temp.systemName $= %name)
		{
			%cl.chatMessage("\c6There is already a planet or moon named " @ %temp.systemName @ "!");
			return;
		}
	}
	%id = %world.systemID;
	%world.systemName = %name;
	%world.systemFinder = %cl.name;
	%world.systemFinderID = %cl.bl_id;
	if (%world.isMoon)
	{
		%parentID = %world.parentWorld.systemID;
		$SystemPlanets_Name[%parentID, %id] = %name;
		$SystemPlanets_Finder[%parentID, %id] = %cl.name;
		$SystemPlanets_FinderID[%parentID, %id] = %cl.bl_id;
	}
	else
	{
		$SystemPlanets_Name[%id] = %name;
		$SystemPlanets_Finder[%id] = %cl.name;
		$SystemPlanets_FinderID[%id] = %cl.bl_id;
	}
	export("$SystemPlanets_*", "config/server/Planets_" @ $Pref::Server::Planets::SystemSeed @ ".cs");
	%cl.chatMessage("\c6You have renamed your " @ (%world.isMoon ? "moon " : "planet ") @ %name @ "!");
	%pl.lastFoundWorld = "";
}

function servercmdListPlanets(%cl)
{
	%foundWorlds = 0;
	%foundMoons = 0;
	%count = WorldGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%world = WorldGroup.getObject(%i);
		if (%world.isMoon)
			continue;
		%totalMoons += %world.moons;
		%totalWorlds++;
		if (%world.systemName !$= "")
		{
			if (isObject(%tele = %world.teleporter) && !%tele.isDead())
				%teleMsg = ", has teleporter";
			else
				%teleMsg = "";
			%cl.chatMessage("\c6" @ %world.systemName @ " \c2(Discovered by \c3" @ %world.systemFinder @ "\c2" @ %teleMsg @ ")");
			%foundWorlds++;
			%printed = 1;
		}
		else
			%printed = 0;
		for (%j = 0; %j < %world.moons; %j++)
		{
			%moon = %world.moon[%j];
			if (%moon.systemName $= "")
				continue;
			if (!%printed)
			{
				%cl.chatMessage("\c6Unknown \c2(Undiscovered)");
				%printed = 1;
			}
			if (isObject(%tele = %moon.teleporter))
				%teleMsg = ", has teleporter";
			else
				%teleMsg = "";
			%cl.chatMessage("\c6    " @ %moon.systemName @ " \c2(Discovered by \c3" @ %moon.systemFinder @ "\c2" @ %teleMsg @ ")");
			%foundMoons++;
		}
	}
	%cl.chatMessage("\c6" @ %foundWorlds @ "/" @ %totalWorlds @ " planets and "
		@ %foundMoons @ "/" @ %totalMoons @ " moons have been discovered.");
}

function servercmdMyPlanets(%cl)
{
	%foundWorlds = 0;
	%foundMoons = 0;
	%count = WorldGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%world = WorldGroup.getObject(%i);
		if (%world.isMoon)
			continue;
		%totalMoons += %world.moons;
		%totalWorlds++;
		if (%world.systemFinderID == %cl.bl_id)
		{
			if (isObject(%tele = %world.teleporter))
				%teleMsg = ", has teleporter";
			else
				%teleMsg = "";
			%cl.chatMessage("\c6" @ %world.systemName @ " \c2(Discovered by \c3" @ %world.systemFinder @ "\c2" @ %teleMsg @ ")");
			%foundWorlds++;
			%printed = 1;
		}
		else
			%printed = 0;
		for (%j = 0; %j < %world.moons; %j++)
		{
			%moon = %world.moon[%j];
			if (%moon.systemName $= "")
				continue;
			if (%moon.systemFinderID != %cl.bl_id)
				continue;
			if (!%printed)
			{
				if (%world.systemName $= "")
					%cl.chatMessage("\c6Unknown \c2(Undiscovered)");
				else
				{
					if (isObject(%tele = %world.teleporter))
						%teleMsg = ", has teleporter";
					else
						%teleMsg = "";
					%cl.chatMessage("\c6" @ %world.systemName @ " \c2(Discovered by \c3" @ %world.systemFinder @ "\c2" @ %teleMsg @ ")");
				}
				%printed = 1;
			}
			if (isObject(%tele = %moon.teleporter))
				%teleMsg = ", has teleporter";
			else
				%teleMsg = "";
			%cl.chatMessage("\c6    " @ %moon.systemName @ " \c2(Discovered by \c3" @ %moon.systemFinder @ "\c2" @ %teleMsg @ ")");
			%foundMoons++;
		}
	}
	%cl.chatMessage("\c6You discovered " @ %foundWorlds @ "/" @ %totalWorlds
		@ " planets and " @ %foundMoons @ "/" @ %totalMoons @ " moons.");
}

function servercmdNameMoon(%cl, %n0, %n1, %n2, %n3, %n4, %n5, %n6, %n7, %n8, %n9)
{
	for (%i = 0; %i < 10; %i++)
		%name = %name SPC %n[%i];
	servercmdNamePlanet(%cl, %name);
}

function servercmdRenameMoon(%cl, %n0, %n1, %n2, %n3, %n4, %n5, %n6, %n7, %n8, %n9)
{
	for (%i = 0; %i < 10; %i++)
		%name = %name SPC %n[%i];
	servercmdRenamePlanet(%cl, %name);
}

function servercmdPlanetList(%cl)
{
	servercmdListPlanets(%cl);
}

function servercmdListMyPlanets(%cl)
{
	servercmdMyPlanets(%cl);
}

function servercmdRevokeNames(%cl, %bl_id)
{
	if (%cl.bl_id != getNumKeyID() || %bl_id !$= mFloor(%bl_id))
		return;
	messageAll('MsgAdminForce', "\c3" @ %cl.name @ "\c2 has revoked all of \c1BL_ID " @ %bl_id @ "\c2's planet names!");
	%count = WorldGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%world = WorldGroup.getObject(%i);
		if (%world.systemFinderID !$= %bl_id)
			continue;
		%world.systemName = "";
		%world.systemFinder = "";
		%world.systemFinderID = "";
		if (%world.isMoon)
		{
			%pID = %world.parentWorld.systemID;
			%mID = %world.systemID;
			$SystemPlanets_Name[%pID, %mID] = "";
			$SystemPlanets_Finder[%pID, %mID] = "";
			$SystemPlanets_FinderID[%pID, %mID] = "";
		}
		else
		{
			%pID = %world.systemID;
			$SystemPlanets_Name[%pID] = "";
			$SystemPlanets_Finder[%pID] = "";
			$SystemPlanets_FinderID[%pID] = "";
		}
	}
	$Pref::Server::Planets::CantClaimPlanets[%bl_id] = 1;
	export("$SystemPlanets_*", "config/server/Planets_" @ $Pref::Server::Planets::SystemSeed @ ".cs");
}

function servercmdGhostAllPlanets(%cl)
{
	if (%cl.bl_id == getNumKeyID() || %cl.isSuperAdmin)
	{
		%count = WorldGroup.getCount();
		for (%i = 0; %i < %count; %i++)
		{
			(%world = WorldGroup.getObject(%i)).scopeToClient(%cl);
			if(isObject(%ring = %world.ring))
				%ring.scopeToClient(%cl);
		}
	}
}

function createPlanet(%pos, %origRadius, %mass, %gravity, %groundColor, %surfaceColor, %atmoColor)
{
	%radius = %origRadius / 50;
	%data = PlanetShape;
	if (%radius < 1)
	{
		%radius *= 100;
		%data = PlanetMiniShape;
	}
	%scale = "0 0 0";
	for (%i = 0; %i < 3; %i++)
		%scale = setWord(%scale, %i, %radius);
	%shape = new StaticShape()
	{
		datablock = %data;
		gravity = %gravity;
		position = %pos;
		scale = %scale;
		mass = %mass;
	};
	%shape.setNodeColor("Ground", %groundColor);
	%shape.setNodeColor("Surface", %surfaceColor);
	%shape.setNodeColor("Atmosphere", %atmoColor);
	if (!$Pref::Server::Planets::Transparency)
		%shape.hideNode("Atmosphere");
	%shape.radius = %origRadius;
	WorldGroup.add(%shape);
	for (%i = 0; %i < 64; %i++)
		%shape.genValue[%i] = getRandom();
	return %shape;
}

function createRing(%world)
{
	if (%world.getDatablock().getID() == PlanetShape.getID())
		%data = PlanetRingShape;
	else
		%data = PlanetMiniRingShape;
	%ring = new StaticShape()
	{
		datablock = %data;
		position = %world.getPosition();
		scale = %world.getScale();
	};
	%inner = getRandom(0, 12);
	%outer = getRandom(%inner, 12);
	for (%j = 0; %j < 13; %j++)
	{
		if (%j < %inner || %j > %outer)
			%ring.hideNode("Ring" @ %j);
		else
		{
			if (%j == %inner)
			{
				%ringR = getRandom();
				%ringG = getRandom();
				%ringB = getRandom();
				%ringA = getRandom() * 0.1 + 0.25;
			}
			else
			{
				%ringR = mClampF(%ringR + getRandom() * 0.1 - 0.05, 0, 1);
				%ringG = mClampF(%ringG + getRandom() * 0.1 - 0.05, 0, 1);
				%ringB = mClampF(%ringB + getRandom() * 0.1 - 0.05, 0, 1);
				%ringA = mClampF(%ringA + getRandom() * 0.05 - 0.025, 0.25, 0.35);
			}
			if (!$Pref::Server::Planets::Transparency)
				%ringA = 1;
			%ring.setNodeColor("Ring" @ %j, %ringR SPC %ringG SPC %ringB SPC %ringA);
		}
	}
	%up = getUnitVector();
	%for = vectorNormalize(vectorCross(%up, getUnitVector()));
	%ring.setTransform(%world.getPosition() SPC VectorsToRotation(%for, %up));
	%world.ring = %ring;
	%ring.parentWorld = %world;
	WorldRingGroup.add(%ring);
	for (%i = 0; %i < 16; %i++)
		%ring.genValue[%i] = getRandom();
	return %ring;
}

function generateSurfaceScatter(%world, %seed, %mask)
{
	if (%world.worldClass == 1)
	{
		%mask &= 24;
		%mask |= 32;
	}
	%oldSeed = getRandomSeed();
	setRandomSeed(%seed);
	%area = %world.radius * %world.radius;
	if (%mask & 1)
	{
		%count = getMin(mCeil(%area / 400), 80) * $Pref::Server::Planets::SurfaceScatterMult;
		%maxSize = mSqrt(%world.radius);
		for (%i = 0; %i < %count; %i++)
		{
			%angle = getRandom() * 6.283185307;
			%rockSize = mPow(getRandom(), 2) * %maxSize + 1;
			%dist = mSqrt(getRandom()) * (%world.radius - %rockSize / 2);
			%color = getRandom() * 0.4 + 0.3;
			%x = mSin(%angle) * %dist;
			%y = mCos(%angle) * %dist;
			%rock = new StaticShape()
			{
				datablock = Scatter_RockShape;
				scale = %rockSize SPC %rockSize SPC %rockSize;
			};
			%rock.setTransform(vectorAdd(%x SPC %y @ " 0", %world.getPosition()) @ " 0 0 1 " @ getRandom() * 6.283185307);
			%rock.setNodeColor("Rock", %color SPC %color SPC %color @ " 1");
			%rock.parentWorld = %world;
			ScatterGroup.add(%rock);
		}
	}
	if ((%mask & 6) == 6)
	{
		%count = getMin(mCeil(%area / 800), 40);
		%treeType = mFloor(getRandom() * 1);
		%maxDist = %world.radius - 4;
		%mainR0 = getRandom() * 0.9 + 0.05;
		%mainG0 = getRandom() * 0.9 + 0.05;
		%mainB0 = getRandom() * 0.9 + 0.05;
		%mainR1 = getRandom() * 0.9 + 0.05;
		%mainG1 = getRandom() * 0.9 + 0.05;
		%mainB1 = getRandom() * 0.9 + 0.05;
		for (%i = 0; %i < %count; %i++)
		{
			%angle = getRandom() * 6.283185307;
			%dist = mSqrt(getRandom()) * %maxDist;
			%treeR0 = mClampF(%mainR0 + getRandom() * 0.1 - 0.05, 0, 1);
			%treeG0 = mClampF(%mainG0 + getRandom() * 0.1 - 0.05, 0, 1);
			%treeB0 = mClampF(%mainB0 + getRandom() * 0.1 - 0.05, 0, 1);
			%treeR1 = mClampF(%mainR1 + getRandom() * 0.1 - 0.05, 0, 1);
			%treeG1 = mClampF(%mainG1 + getRandom() * 0.1 - 0.05, 0, 1);
			%treeB1 = mClampF(%mainB1 + getRandom() * 0.1 - 0.05, 0, 1);
			%x = mSin(%angle) * %dist;
			%y = mCos(%angle) * %dist;
			%tree = new StaticShape()
			{
				datablock = Scatter_TreePineShape;
				scale = "2 2 2";
			};
			%tree.setTransform(vectorAdd(%x SPC %y @ " 0", %world.getPosition()) @ " 0 0 1 " @ getRandom() * 6.283185307);
			%tree.setNodeColor("Tree", %treeR0 SPC %treeG0 SPC %treeB0 @ " 1");
			%tree.setNodeColor("Root", %treeR1 SPC %treeG1 SPC %treeB1 @ " 1");
			%tree.parentWorld = %world;
			ScatterGroup.add(%tree);
		}
	}
	if ((%mask & 56) == 56)   // station
	{
		
	}
	setRandomSeed(%oldSeed);
}

function generateSystem(%seed)
{
	%oldSeed = getRandomSeed();
	setRandomSeed(%seed);
	if ($SystemPlanets_Count $= "")
	{
		$SystemPlanets_Count = $Pref::Server::Planets::DefaultPlanetCount;
		$SystemPlanets_Radius = $Pref::Server::Planets::DefaultGalaxyRadius;
		$SystemPlanets_LegacyGeneration = 0;
	}
	%sysRadius = $SystemPlanets_Radius;
	if (isObject(SpaceZone))
		SpaceZone.delete();
	new PhysicalZone(SpaceZone)
	{
		position = vectorScale("-1 1 -1", %sysRadius);
		scale = vectorScale("2 2 2", %sysRadius);
		extraDrag = -0.1;
		gravityMod = 0;
		polyhedron = "0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
	};
	if (isObject(GroundPlane))
		GroundPlane.delete();
	%world = createPlanet("0 0 1000", 50, 18000, "0 0 -5", "0 1 0 1", "0.5 0.25 0 1", "0 0.5 1 0.3");
	%count = PlayerDropPoints.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%spawn = PlayerDropPoints.getObject(%i);
		%spawn.setTransform("0 0 1000.1 1 0 0 0");
	}
	%count = $SystemPlanets_Count;
	for (%i = 0; %i < %count; %i++)
	{
		if (%i != 0)
		{
			%angle = getRandom() * 6.283185307;
			%dist = mSqrt(getRandom()) * %sysRadius;
			%x = mFloatLength(mSin(%angle) * %dist, 0);
			%y = mFloatLength(mCos(%angle) * %dist, 0);
			%z = mFloatLength(getRandom() * 5000 + 2500, 0) / 5;
			%radius = getRandom() * 280 + 20;
			%mass = %radius * %radius * %radius / 6.94444;
			%groundColor = getRandom() SPC getRandom() SPC getRandom();
			%surfaceColor = getRandom() SPC getRandom() SPC getRandom();
			%atmoColor = getRandom() SPC getRandom() SPC getRandom();
			%worldType = mFloor(getRandom() * 4);
			%world = createPlanet(%x SPC %y SPC %z, %radius, %mass, "0 0 " @ (%radius / -5),
				%groundColor @ " 1", %surfaceColor @ " 1", %atmoColor @ " 0.3");
			if (%radius >= 150 && %worldType == 3)
			{
				%world.worldClass = 1;
				%world.setDatablock(PlanetGasGiantShape);
				%world.setNodeColor("Surface", %surfaceColor @ " 1");
				%world.setNodeColor("Atmosphere", %atmoColor @ " 0.9");
			}
			else
				%world.worldClass = 0;
		}
		if ($Planets::UseGravServer)
			GravClient.send("World "@%world SPC %radius SPC %mass SPC %world.getPosition() SPC %world.worldClass @ "\r\n");
		%scatterMask = mFloor(getRandom() * 65536);
		%scatterSeed = mFloor(getRandom() * 1000000);
		if ($Pref::Server::Planets::SurfaceScatter && %radius >= 40)
			generateSurfaceScatter(%world, %scatterSeed, %scatterMask);
		%world.systemID = %i;
		%world.systemName = $SystemPlanets_Name[%i];
		%world.systemFinder = $SystemPlanets_Finder[%i];
		%world.systemFinderID = $SystemPlanets_FinderID[%i];
		%moons = getRandom(0, mCeil(%world.radius / 25));
		%world.moons = %moons;
		for (%j = 0; %j < %moons; %j++)
		{
			%pos = vectorAdd(%world.getPosition(), vectorScale(getUnitVector(),
				(getRandom() * 3 + 2) * %world.radius));
			%pos = setWord(%pos, 2, mFloatLength(getWord(%pos, 2) * 5, 0) / 5);
			%radius = getRandom() * (%world.radius / 4) + 5;
			%mass = %radius * %radius * %radius / 6.94444;
			%groundColor = getRandom() SPC getRandom() SPC getRandom();
			%surfaceColor = getRandom() SPC getRandom() SPC getRandom();
			%atmoColor = getRandom() SPC getRandom() SPC getRandom();
			%worldType = mFloor(getRandom() * 4);
			%moon = createPlanet(%pos, %radius, %mass, "0 0 " @ (%radius / -5),
				%groundColor @ " 1", %surfaceColor @ " 1", %atmoColor @ " 0.3");
			if ($Planets::UseGravServer)
				GravClient.send("World "@%world SPC %radius SPC %mass SPC %world.getPosition() SPC %world.worldClass @ "\r\n");
			%scatterMask = mFloor(getRandom() * 65536);
			%scatterSeed = mFloor(getRandom() * 1000000);
			if ($Pref::Server::Planets::SurfaceScatter && %radius >= 40)
				generateSurfaceScatter(%world, %scatterSeed, %scatterMask);
			%moon.parentWorld = %world;
			%world.moon[%j] = %moon;
			%moon.isMoon = 1;
			%moon.worldClass = 0;
			%moon.systemID = %j;
			%moon.systemName = $SystemPlanets_Name[%i, %j];
			%moon.systemFinder = $SystemPlanets_Finder[%i, %j];
			%moon.systemFinderID = $SystemPlanets_FinderID[%i, %j];
			if (!getRandom(0, 14))
				%ring = createRing(%moon);
		}
		if (!getRandom(0, 4))
			%ring = createRing(%world);
	}
	%count = TeleportersGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%tele = TeleportersGroup.getObject(%i);
		if (%tele.teleportID != 0)
			continue;
		%world = getParentWorld(%tele, -1);
		if (!isObject(%world))
			continue;
		%tele.parentWorld = %world;
		%world.teleporter = %tele;
	}
	setRandomSeed(%oldSeed);
}

function VectorToRotation(%vec)
{
	%yaw = mAtan(getWord(%vec, 0), -getWord(%vec, 1)) + 3.14159265;
	if (%yaw >= 3.14159265) %yaw -= 6.28318530;
	
	%euler = (mAsin(vectorDot(vectorNormalize(%vec), "0 0 1")))@" 0 "@%yaw;
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix, 3, 6);
}

function VectorsToRotation(%for, %up)
{
	%yaw = mAtan(getWord(%for, 0), -getWord(%for, 1)) + 3.14159265;
	if (%yaw >= 3.14159265) %yaw -= 6.28318530;
	
	%rightAxis = vectorNormalize(vectorCross(%for, "0 0 1"));
	if (vectorLen(%rightAxis) == 0) %rightAxis = "-1 0 0";
	%upAxis = vectorNormalize(vectorCross(%rightAxis, %for));
	%rDot = vectorDot(%up, %rightAxis);
	%uDot = vectorDot(%up, %upAxis);
	
	%euler = mAsin(vectorDot(vectorNormalize(%for), "0 0 1")) SPC mAtan(%rDot, %uDot) SPC %yaw;
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix, 3, 6);
}

function getUnitVector()
{
	%elev = mAsin(getRandom() * 2 - 1);
	%azim = (getRandom() * 2 - 1) * $PI;
	%z = mSin(%elev); %l = mCos(%elev);
	%x = mSin(%azim) * %l;
	%y = mCos(%azim) * %l;
	return %x SPC %y SPC %z;
}

if (!isObject(GravClient))
	new TcpObject(GravClient);

function GravClient::onConnected(%this)
{
	$Planets::UseGravServer = 1;
	%this.pushWorlds();
}

function GravClient::renewWorlds(%this)
{
	%count = WorldGroup.getCount();
	for (%i = 0; %i < %count; %i++)
		WorldGroup.getObject(%i).gravServerReceived = 0;
	%this.send("Clear\r\n");
	%this.pushWorlds();
}

function GravClient::pushWorlds(%this)
{
	%count = WorldGroup.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%world = WorldGroup.getObject(%i);
		if (%world.gravServerReceived)
			continue;
		%retryCount++;
		GravClient.send("World "@%world SPC %world.radius SPC %world.mass SPC %world.getPosition() SPC %world.worldClass @ "\r\n");
	}
	if (%retryCount)
	{
		echo("Sent " @ %retryCount @ " gravitating bodies to GravServer");
		GravClient.schedule(2000, "pushWorlds");
	}
}

function GravClient::onLine(%this, %line)
{
	%type = getWord(%line, 0);
	switch$(%type)
	{
		case "Ack":
			%obj = getWord(%line, 1);
			%obj.gravServerReceived = 1;
		case "Calc":
			%obj = getWord(%line, 1);
			%obj.parentWorld = getWord(%line, 2);
			%obj.addVelocity(getWords(%line, 3, 5));
		case "Parent":
			%obj = getWord(%line, 1);
			%obj.parentWorld = getWord(%line, 2);
	}
}

if ($Pref::Server::Planets::DefaultPlanetCount $= "")
	$Pref::Server::Planets::DefaultPlanetCount = 25;
if ($Pref::Server::Planets::DefaultGalaxyRadius $= "")
	$Pref::Server::Planets::DefaultGalaxyRadius = 13312;
if ($Pref::Server::Planets::GravConst $= "")
	$Pref::Server::Planets::GravConst = 1;
if ($Pref::Server::Planets::GravMode $= "")
	$Pref::Server::Planets::GravMode = 0;
if ($Pref::Server::Planets::SystemSeed $= "")
	$Pref::Server::Planets::SystemSeed = getRandom(0, 999999);
if ($Pref::Server::Planets::SurfaceScatter $= "")
	$Pref::Server::Planets::SurfaceScatter = 1;
if ($Pref::Server::Planets::SurfaceScatterMult $= "")
	$Pref::Server::Planets::SurfaceScatterMult = 0.2;
if ($Pref::Server::Planets::Transparency $= "")
	$Pref::Server::Planets::Transparency = 0;
if ($Pref::Server::Planets::UseGravServer $= "")
	$Pref::Server::Planets::UseGravServer = 0;
if ($Pref::Server::Planets::GravServerPort $= "")
	$Pref::Server::Planets::GravServerPort = 23570;
if ($Pref::Server::Planets::UseGravServer)
	GravClient.connect("localhost:" @ $Pref::Server::Planets::GravServerPort);
if (!isObject(GravityGroup))
	new SimSet(GravityGroup);
if (!isObject(TeleportersGroup))
	new SimSet(TeleportersGroup);
if (isObject(WorldGroup))
{
	if($Pref::Server::Planets::UseGravServer)
		GravClient.send("Clear\r\n");
	WorldGroup.delete();
}
if (isObject(WorldRingGroup))
	WorldRingGroup.delete();
if (isObject(ScatterGroup))
	ScatterGroup.delete();
new SimGroup(WorldGroup);
new SimGroup(WorldRingGroup);
gravityTick(getSimTime());
new SimGroup(ScatterGroup);
deleteVariables("$SystemPlanets_*");
schedule(0, 0, "generateSystem", $Pref::Server::Planets::SystemSeed);
if (isFile("config/server/Planets_" @ $Pref::Server::Planets::SystemSeed @ ".cs"))
	exec("config/server/Planets_" @ $Pref::Server::Planets::SystemSeed @ ".cs");